Index: /palm/trunk/SOURCE/modules.f90
===================================================================
--- /palm/trunk/SOURCE/modules.f90	(revision 2276)
+++ /palm/trunk/SOURCE/modules.f90	(revision 2277)
@@ -1408,5 +1414,5 @@
     USE kinds
 
-    CHARACTER (LEN=10) ::  dvrp_output = 'rtsp'        !< 
+    CHARACTER (LEN=10) ::  dvrp_output = 'rtsp'        !< Siggi (entire MODULE)
     CHARACTER (LEN=10) ::  particle_color = 'none'     !< 
     CHARACTER (LEN=10) ::  particle_dvrpsize = 'none'  !< 
@@ -1448,5 +1454,5 @@
     LOGICAL ::  dvrp_overlap                               !< 
     LOGICAL ::  dvrp_total_overlap                         !< 
-    LOGICAL ::  local_dvrserver_running                    !< 
+    LOGICAL ::  local_dvrserver_running                    !< internally set namelist parameter
     LOGICAL ::  lock_steering_update = .FALSE.             !< 
     LOGICAL ::  use_seperate_pe_for_dvrp_output = .FALSE.  !< 
@@ -1526,18 +1532,18 @@
     USE kinds
 
-    REAL(wp) ::  ddx          !< 
-    REAL(wp) ::  ddx2         !< 
-    REAL(wp) ::  dx = 1.0_wp  !< 
-    REAL(wp) ::  dx2          !< 
-    REAL(wp) ::  ddy          !< 
-    REAL(wp) ::  ddy2         !< 
-    REAL(wp) ::  dy = 1.0_wp  !< 
-    REAL(wp) ::  dy2          !< 
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ddx2_mg  !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ddy2_mg  !< 
-
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  zu_s_inner  !<  
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  zw_w_inner  !< 
+    REAL(wp) ::  ddx          !< 1/dx
+    REAL(wp) ::  ddx2         !< 1/dx2
+    REAL(wp) ::  dx = 1.0_wp  !< horizontal grid size (along x-direction) 
+    REAL(wp) ::  dx2          !< dx*dx
+    REAL(wp) ::  ddy          !< 1/dy
+    REAL(wp) ::  ddy2         !< 1/dy2
+    REAL(wp) ::  dy = 1.0_wp  !< horizontal grid size (along y-direction)
+    REAL(wp) ::  dy2          !< dy*dy
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ddx2_mg  !< 1/dx_l**2 (dx_l: grid spacing along x on different multigrid level)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  ddy2_mg  !< 1/dy_l**2 (dy_l: grid spacing along y on different multigrid level)
+
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  zu_s_inner  !< height of topography top on scalar grid 
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  zw_w_inner  !< height of topography top on w grid 
                                               
     SAVE
@@ -1555,77 +1561,77 @@
     USE kinds
 
-    INTEGER(iwp) ::  nbgp = 3     !< 
-    INTEGER(iwp) ::  ngp_sums     !< 
-    INTEGER(iwp) ::  ngp_sums_ls  !< 
-    INTEGER(iwp) ::  nnx          !< 
-    INTEGER(iwp) ::  nx = 0       !< 
-    INTEGER(iwp) ::  nx_a         !< 
-    INTEGER(iwp) ::  nx_o         !< 
-    INTEGER(iwp) ::  nxl          !< 
-    INTEGER(iwp) ::  nxlg         !< 
-    INTEGER(iwp) ::  nxlu         !< 
-    INTEGER(iwp) ::  nxr          !< 
-    INTEGER(iwp) ::  nxrg         !< 
-    INTEGER(iwp) ::  nx_on_file   !< 
-    INTEGER(iwp) ::  nny          !< 
-    INTEGER(iwp) ::  ny = 0       !< 
-    INTEGER(iwp) ::  ny_a         !< 
-    INTEGER(iwp) ::  ny_o         !< 
-    INTEGER(iwp) ::  nyn          !< 
-    INTEGER(iwp) ::  nyng         !< 
-    INTEGER(iwp) ::  nys          !< 
-    INTEGER(iwp) ::  nysg         !< 
-    INTEGER(iwp) ::  nysv         !< 
-    INTEGER(iwp) ::  ny_on_file   !< 
-    INTEGER(iwp) ::  nnz          !< 
-    INTEGER(iwp) ::  nz = 0       !< 
-    INTEGER(iwp) ::  nzb          !< 
-    INTEGER(iwp) ::  nzb_diff     !< 
-    INTEGER(iwp) ::  nzb_max      !< 
-    INTEGER(iwp) ::  nzt          !< 
-
-    INTEGER(idp), DIMENSION(:), ALLOCATABLE ::  ngp_3d        !< 
+    INTEGER(iwp) ::  nbgp = 3     !< number of boundary ghost points
+    INTEGER(iwp) ::  ngp_sums     !< number of vertical profile grid points time number of output profiles - used for allreduce statements in MPI calls
+    INTEGER(iwp) ::  ngp_sums_ls  !< number of vertical profile grid points time number of large-scale forcing profiles - used for allreduce statements in MPI calls
+    INTEGER(iwp) ::  nnx          !< number of subdomain grid points in x-direction
+    INTEGER(iwp) ::  nx = 0       !< nx+1 = total number of grid points in x-direction
+    INTEGER(iwp) ::  nx_a         !< Siggi
+    INTEGER(iwp) ::  nx_o         !< Siggi
+    INTEGER(iwp) ::  nxl          !< left-most grid index of subdomain (excluding ghost points)
+    INTEGER(iwp) ::  nxlg         !< left-most grid index of subdomain (including ghost points)
+    INTEGER(iwp) ::  nxlu         !< =nxl+1 (at left domain boundary with inflow from left), else =nxl
+    INTEGER(iwp) ::  nxr          !< right-most grid index of subdomain (excluding ghost points)
+    INTEGER(iwp) ::  nxrg         !< right-most grid index of subdomain (including ghost points)
+    INTEGER(iwp) ::  nx_on_file   !< nx of previous run in job chain
+    INTEGER(iwp) ::  nny          !< number of subdomain grid points in y-direction
+    INTEGER(iwp) ::  ny = 0       !< ny+1 = total number of grid points in y-direction
+    INTEGER(iwp) ::  ny_a         !< Siggi
+    INTEGER(iwp) ::  ny_o         !< Siggi
+    INTEGER(iwp) ::  nyn          !< north-most grid index of subdomain (excluding ghost points)
+    INTEGER(iwp) ::  nyng         !< north-most grid index of subdomain (including ghost points)
+    INTEGER(iwp) ::  nys          !< south-most grid index of subdomain (excluding ghost points)
+    INTEGER(iwp) ::  nysg         !< south-most grid index of subdomain (including ghost points)
+    INTEGER(iwp) ::  nysv         !< =nys+1 (at south domain boundary with inflow from south), else =nys
+    INTEGER(iwp) ::  ny_on_file   !< ny of previous run in job chain
+    INTEGER(iwp) ::  nnz          !< number of subdomain grid points in z-direction
+    INTEGER(iwp) ::  nz = 0       !< total number of grid points in z-direction
+    INTEGER(iwp) ::  nzb          !< bottom grid index of computational domain
+    INTEGER(iwp) ::  nzb_diff     !< will be removed
+    INTEGER(iwp) ::  nzb_max      !< vertical index of topography top
+    INTEGER(iwp) ::  nzt          !< nzt+1 = top grid index of computational domain
+
+    INTEGER(idp), DIMENSION(:), ALLOCATABLE ::  ngp_3d        !< number of grid points of the total domain
     INTEGER(idp), DIMENSION(:), ALLOCATABLE ::  ngp_3d_inner  !< ! need to have 64 bit for grids > 2E9
                     
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ngp_2dh  !< 
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nxl_mg   !< 
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nxr_mg   !< 
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nyn_mg   !< 
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nys_mg   !< 
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nzt_mg   !< 
-
-
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  ngp_2dh_outer     !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  ngp_2dh_s_inner   !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mg_loc_ind        !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_diff_s_inner  !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_diff_s_outer  !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_inner         !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_outer         !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_s_inner       !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_s_outer       !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_u_inner       !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_u_outer       !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_v_inner       !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_v_outer       !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_w_inner       !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_w_outer       !< 
-
-    INTEGER(iwp), DIMENSION(:,:,:), POINTER ::  flags  !<
-
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_1   !< 
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_2   !< 
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_3   !<
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_4   !< 
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_5   !< 
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_6   !< 
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_7   !< 
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_8   !< 
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_9   !< 
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_10  !< 
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ngp_2dh  !< number of grid points of a horizontal cross section through the total domain
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nxl_mg   !< left-most grid index of subdomain on different multigrid level
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nxr_mg   !< right-most grid index of subdomain on different multigrid level
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nyn_mg   !< north-most grid index of subdomain on different multigrid level
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nys_mg   !< south-most grid index of subdomain on different multigrid level
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  nzt_mg   !< top-most grid index of subdomain on different multigrid level
+
+
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  ngp_2dh_outer     !< number of horizontal grid points which are non-topography and non-surface-bounded
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  ngp_2dh_s_inner   !< number of horizontal grid points which are non-topography
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  mg_loc_ind        !< Siggi
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_diff_s_inner  !< will be removed
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_diff_s_outer  !< will be removed
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_inner         !< will be removed
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_outer         !< will be removed
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_s_inner       !< will be removed
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_s_outer       !< will be removed
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_u_inner       !< will be removed
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_u_outer       !< will be removed
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_v_inner       !< will be removed
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_v_outer       !< will be removed
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_w_inner       !< will be removed
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  nzb_w_outer       !< will be removed
+
+    INTEGER(iwp), DIMENSION(:,:,:), POINTER ::  flags  !< pointer to wall_flags_1-10
+
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_1   !< topograpyh masking flag on multigrid level 1 
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_2   !< topograpyh masking flag on multigrid level 2 
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_3   !< topograpyh masking flag on multigrid level 3 
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_4   !< topograpyh masking flag on multigrid level 4 
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_5   !< topograpyh masking flag on multigrid level 5 
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_6   !< topograpyh masking flag on multigrid level 6 
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_7   !< topograpyh masking flag on multigrid level 7 
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_8   !< topograpyh masking flag on multigrid level 8 
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_9   !< topograpyh masking flag on multigrid level 9 
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE,  TARGET ::  wall_flags_10  !< topograpyh masking flag on multigrid level 10 
 
     INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  advc_flags_1            !< flags used to degrade order of advection scheme
     INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  advc_flags_2            !< flags used to degrade order of advection scheme
-    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  wall_flags_0            !< flags to mask topography
+    INTEGER(iwp), DIMENSION(:,:,:), ALLOCATABLE ::  wall_flags_0            !< flags to mask topography and surface-bounded grid points
 
     SAVE
@@ -1653,5 +1659,5 @@
           USE kinds
 
-          CHARACTER (LEN=*), INTENT(IN) ::  mode                     !< 
+          CHARACTER (LEN=*), INTENT(IN) ::  mode                     !< Siggi (entire module, some variables are still in German)
           INTEGER(iwp), INTENT(IN)      ::  i1                       !< 
           INTEGER(iwp), INTENT(IN)      ::  i2                       !< 
@@ -1695,9 +1701,9 @@
           USE kinds
 
-          CHARACTER (LEN=*), INTENT(IN) ::  sk_char  !< 
+          CHARACTER (LEN=*), INTENT(IN) ::  sk_char  !< string for treated scalar in Bott-Chlond scheme
 #if defined( __nopointer )
-          REAL(wp), DIMENSION(:,:,:) ::  sk  !< 
+          REAL(wp), DIMENSION(:,:,:) ::  sk  !< treated scalar array in Bott-Chlond scheme
 #else
-          REAL(wp), DIMENSION(:,:,:), POINTER ::  sk  !< 
+          REAL(wp), DIMENSION(:,:,:), POINTER ::  sk  !< treated scalar array in Bott-Chlond scheme
 #endif
        END SUBROUTINE advec_s_bc
@@ -1719,46 +1725,46 @@
     USE kinds
 
-    INTEGER(iwp) ::  current_timestep_number_1d = 0  !< 
-    INTEGER(iwp) ::  damp_level_ind_1d               !< 
-
-    LOGICAL ::  run_control_header_1d = .FALSE.  !< 
-    LOGICAL ::  stop_dt_1d = .FALSE.             !< 
-
-    REAL(wp) ::  damp_level_1d = -1.0_wp       !< 
-    REAL(wp) ::  dt_1d = 60.0_wp               !< 
-    REAL(wp) ::  dt_max_1d = 300.0_wp          !< 
-    REAL(wp) ::  dt_pr_1d = 9999999.9_wp       !< 
-    REAL(wp) ::  dt_run_control_1d = 60.0_wp   !< 
-    REAL(wp) ::  end_time_1d = 864000.0_wp     !< 
-    REAL(wp) ::  old_dt_1d = 1.0E-10_wp        !< 
-    REAL(wp) ::  qs1d                          !< 
-    REAL(wp) ::  simulated_time_1d = 0.0_wp    !< 
-    REAL(wp) ::  time_pr_1d = 0.0_wp           !< 
-    REAL(wp) ::  time_run_control_1d = 0.0_wp  !< 
-    REAL(wp) ::  ts1d                          !< 
-    REAL(wp) ::  us1d                          !< 
-    REAL(wp) ::  usws1d                        !< 
-    REAL(wp) ::  vsws1d                        !<               
-    REAL(wp) ::  z01d                          !< 
-    REAL(wp) ::  z0h1d                         !< 
-
-
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  e1d      !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  e1d_p    !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  kh1d     !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  km1d     !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  l_black  !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  l1d      !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  rif1d    !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  te_e     !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  te_em    !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  te_u     !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  te_um    !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  te_v     !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  te_vm    !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  u1d      !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  u1d_p    !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  v1d      !< 
-    REAL(wp), DIMENSION(:), ALLOCATABLE ::  v1d_p    !< 
+    INTEGER(iwp) ::  current_timestep_number_1d = 0  !< current timestep number (1d-model)
+    INTEGER(iwp) ::  damp_level_ind_1d               !< lower grid index of damping layer (1d-model)
+
+    LOGICAL ::  run_control_header_1d = .FALSE.  !< flag for output of run control header (1d-model)
+    LOGICAL ::  stop_dt_1d = .FALSE.             !< termination flag, used in case of too small timestep (1d-model)
+
+    REAL(wp) ::  damp_level_1d = -1.0_wp       !< namelist parameter
+    REAL(wp) ::  dt_1d = 60.0_wp               !< dynamic timestep (1d-model)
+    REAL(wp) ::  dt_max_1d = 300.0_wp          !< timestep limit (1d-model)
+    REAL(wp) ::  dt_pr_1d = 9999999.9_wp       !< namelist parameter
+    REAL(wp) ::  dt_run_control_1d = 60.0_wp   !< namelist parameter
+    REAL(wp) ::  end_time_1d = 864000.0_wp     !< namelist parameter
+    REAL(wp) ::  old_dt_1d = 1.0E-10_wp        !< previous timestep (1d-model)
+    REAL(wp) ::  qs1d                          !< characteristic humidity scale (1d-model)
+    REAL(wp) ::  simulated_time_1d = 0.0_wp    !< updated simulated time (1d-model)
+    REAL(wp) ::  time_pr_1d = 0.0_wp           !< updated simulated time for profile output (1d-model)
+    REAL(wp) ::  time_run_control_1d = 0.0_wp  !< updated simulated time for run-control output (1d-model)
+    REAL(wp) ::  ts1d                          !< characteristic temperature scale (1d-model)
+    REAL(wp) ::  us1d                          !< friction velocity (1d-model)
+    REAL(wp) ::  usws1d                        !< u-component of the momentum flux (1d-model)
+    REAL(wp) ::  vsws1d                        !< v-component of the momentum flux (1d-model)    
+    REAL(wp) ::  z01d                          !< roughness length for momentum (1d-model)
+    REAL(wp) ::  z0h1d                         !< roughness length for scalars (1d-model)
+
+
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  e1d      !< tke (1d-model)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  e1d_p    !< prognostic value of tke (1d-model)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  kh1d     !< turbulent diffusion coefficient for heat (1d-model)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  km1d     !< turbulent diffusion coefficient for momentum (1d-model)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  l_black  !< mixing length Blackadar (1d-model)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  l1d      !< mixing length (1d-model)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  rif1d    !< Richardson flux number (1d-model)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  te_e     !< Tobias (1d-model)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  te_em    !< Tobias (1d-model)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  te_u     !< Tobias (1d-model)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  te_um    !< Tobias (1d-model)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  te_v     !< Tobias (1d-model)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  te_vm    !< Tobias (1d-model)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  u1d      !< u-velocity component (1d-model)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  u1d_p    !< prognostic value of u-velocity component (1d-model)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  v1d      !< v-velocity component (1d-model)
+    REAL(wp), DIMENSION(:), ALLOCATABLE ::  v1d_p    !< prognostic value of v-velocity component (1d-model)
 
     SAVE
@@ -1787,85 +1793,85 @@
 #endif
 #endif
-    CHARACTER(LEN=2) ::  send_receive = 'al'
-    CHARACTER(LEN=7) ::  myid_char = ''
+    CHARACTER(LEN=2) ::  send_receive = 'al'     !< Siggi
+    CHARACTER(LEN=7) ::  myid_char = ''          !< character string containing processor id number
     
-    INTEGER(iwp) ::  comm1dx                     !< 
-    INTEGER(iwp) ::  comm1dy                     !< 
-    INTEGER(iwp) ::  comm2d                      !< 
-    INTEGER(iwp) ::  comm_inter                  !< 
-    INTEGER(iwp) ::  comm_palm                   !< 
-    INTEGER(iwp) ::  id_inflow = 0               !< 
+    INTEGER(iwp) ::  comm1dx                     !< Siggi
+    INTEGER(iwp) ::  comm1dy                     !< Siggi
+    INTEGER(iwp) ::  comm2d                      !< Siggi
+    INTEGER(iwp) ::  comm_inter                  !< Siggi
+    INTEGER(iwp) ::  comm_palm                   !< Siggi
+    INTEGER(iwp) ::  id_inflow = 0               !< myidx of procs at inflow (turbulent inflow method)
     INTEGER(iwp) ::  id_outflow = 0              !< myidx of procs at outflow (turbulent outflow method)
     INTEGER(iwp) ::  id_outflow_source = 0       !< myidx of procs including ouflow source plane (turbulent outflow method)
-    INTEGER(iwp) ::  id_recycling = 0            !< 
-    INTEGER(iwp) ::  ierr                        !< 
-    INTEGER(iwp) ::  myid = 0                    !< 
-    INTEGER(iwp) ::  myidx = 0                   !< 
-    INTEGER(iwp) ::  myidy = 0                   !< 
-    INTEGER(iwp) ::  ndim = 2                    !< 
-    INTEGER(iwp) ::  ngp_a                       !<
-    INTEGER(iwp) ::  ngp_o                       !<
-    INTEGER(iwp) ::  ngp_xy                      !< 
-    INTEGER(iwp) ::  ngp_y                       !< 
-    INTEGER(iwp) ::  npex = -1                   !< 
-    INTEGER(iwp) ::  npey = -1                   !< 
-    INTEGER(iwp) ::  numprocs = 1                !< 
-    INTEGER(iwp) ::  numprocs_previous_run = -1  !< 
-    INTEGER(iwp) ::  pleft                       !< 
-    INTEGER(iwp) ::  pnorth                      !< 
-    INTEGER(iwp) ::  pright                      !< 
-    INTEGER(iwp) ::  psouth                      !< 
-    INTEGER(iwp) ::  req_count = 0               !< 
-    INTEGER(iwp) ::  sendrecvcount_xy            !< 
-    INTEGER(iwp) ::  sendrecvcount_yz            !< 
-    INTEGER(iwp) ::  sendrecvcount_zx            !< 
-    INTEGER(iwp) ::  sendrecvcount_zyd           !< 
-    INTEGER(iwp) ::  sendrecvcount_yxd           !< 
-    INTEGER(iwp) ::  target_id                   !< 
-    INTEGER(iwp) ::  tasks_per_node = -9999      !< 
-    INTEGER(iwp) ::  threads_per_task = 1        !< 
-    INTEGER(iwp) ::  type_x                      !< 
-    INTEGER(iwp) ::  type_xy                     !< 
-    INTEGER(iwp) ::  type_y                      !< 
-
-    INTEGER(iwp) ::  pdims(2) = 1  !< 
-    INTEGER(iwp) ::  req(100)      !< 
-
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  hor_index_bounds               !< 
-    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  hor_index_bounds_previous_run  !< 
-
-    LOGICAL ::  collective_wait = .FALSE.          !< 
-    LOGICAL ::  sendrecv_in_background = .FALSE.   !< 
+    INTEGER(iwp) ::  id_recycling = 0            !< myidx of procs containing the recycling plane (turbulence recycling method)
+    INTEGER(iwp) ::  ierr                        !< Siggi
+    INTEGER(iwp) ::  myid = 0                    !< id number of processor element
+    INTEGER(iwp) ::  myidx = 0                   !< id number of processor elements with same position along x-direction
+    INTEGER(iwp) ::  myidy = 0                   !< id number of processor elements with same position along y-direction
+    INTEGER(iwp) ::  ndim = 2                    !< Siggi
+    INTEGER(iwp) ::  ngp_a                       !< number of grid points in atmosphere domain   Siggi
+    INTEGER(iwp) ::  ngp_o                       !< number of grid points in ocean domain   Siggi
+    INTEGER(iwp) ::  ngp_xy                      !< number of grid points at atmosphere-ocean interface   Siggi   
+    INTEGER(iwp) ::  ngp_y                       !< Siggi
+    INTEGER(iwp) ::  npex = -1                   !< number of processor elements in x-direction
+    INTEGER(iwp) ::  npey = -1                   !< number of processor elements in y-direction
+    INTEGER(iwp) ::  numprocs = 1                !< total number of appointed processor elements
+    INTEGER(iwp) ::  numprocs_previous_run = -1  !< total number of appointed processor elements in previous run (job chain)
+    INTEGER(iwp) ::  pleft                       !< MPI-address of the processor left of the current one
+    INTEGER(iwp) ::  pnorth                      !< MPI-address of the processor north of the current one
+    INTEGER(iwp) ::  pright                      !< MPI-address of the processor right of the current one
+    INTEGER(iwp) ::  psouth                      !< MPI-address of the processor south of the current one
+    INTEGER(iwp) ::  req_count = 0               !< MPI return variable - checks if Send-Receive operation is already finished
+    INTEGER(iwp) ::  sendrecvcount_xy            !< Siggi
+    INTEGER(iwp) ::  sendrecvcount_yz            !< Siggi
+    INTEGER(iwp) ::  sendrecvcount_zx            !< Siggi
+    INTEGER(iwp) ::  sendrecvcount_zyd           !< Siggi
+    INTEGER(iwp) ::  sendrecvcount_yxd           !< Siggi
+    INTEGER(iwp) ::  target_id                   !< Siggi
+    INTEGER(iwp) ::  tasks_per_node = -9999      !< MPI tasks per computing node 
+    INTEGER(iwp) ::  threads_per_task = 1        !< OPENMP threads per MPI task
+    INTEGER(iwp) ::  type_x                      !< derived MPI datatype for 2-D ghost-point exchange - north / south 
+    INTEGER(iwp) ::  type_xy                     !< derived MPI datatype for 2-D ghost-point exchange - north / south 
+    INTEGER(iwp) ::  type_y                      !< derived MPI datatype for 2-D exchange in atmosphere-ocean coupler 
+
+    INTEGER(iwp) ::  pdims(2) = 1  !< number of processors along x-y dimension
+    INTEGER(iwp) ::  req(100)      !< MPI return variable indicating if send-receive operation is finished
+
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  hor_index_bounds               !< horizontal index bounds 
+    INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE ::  hor_index_bounds_previous_run  !< horizontal index bounds of previous run
+
+    LOGICAL ::  collective_wait = .FALSE.          !< Siggi
+    LOGICAL ::  sendrecv_in_background = .FALSE.   !< Siggi
 
 #if defined( __parallel )
 #if defined( __mpi2 )
-    CHARACTER (LEN=MPI_MAX_PORT_NAME) ::  port_name  !< 
+    CHARACTER (LEN=MPI_MAX_PORT_NAME) ::  port_name  !< Siggi
 #endif
 
-    INTEGER(iwp) ::  ibuf(12)                 !< 
-    INTEGER(iwp) ::  pcoord(2)                !< 
-    INTEGER(iwp) ::  status(MPI_STATUS_SIZE)  !< 
+    INTEGER(iwp) ::  ibuf(12)                 !< Siggi
+    INTEGER(iwp) ::  pcoord(2)                !< Siggi
+    INTEGER(iwp) ::  status(MPI_STATUS_SIZE)  !< Siggi
     
-    INTEGER(iwp), DIMENSION(MPI_STATUS_SIZE,100) ::  wait_stat  !< 
+    INTEGER(iwp), DIMENSION(MPI_STATUS_SIZE,100) ::  wait_stat  !< Siggi
     
-    INTEGER(iwp) ::  ngp_yz_int   !< 
-    INTEGER(iwp) ::  type_xz_int  !< 
-    INTEGER(iwp) ::  type_yz_int  !< 
-
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ngp_xz      !< 
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ngp_yz      !< 
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  type_x_int  !< 
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  type_xz     !< 
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  type_y_int  !< 
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  type_yz     !< 
-
-    LOGICAL ::  left_border_pe  = .FALSE.  !< 
-    LOGICAL ::  north_border_pe = .FALSE.  !< 
-    LOGICAL ::  reorder = .TRUE.           !< 
-    LOGICAL ::  right_border_pe = .FALSE.  !< 
-    LOGICAL ::  south_border_pe = .FALSE.  !< 
-
-    LOGICAL, DIMENSION(2) ::  cyclic = (/ .TRUE. , .TRUE. /)  !< 
-    LOGICAL, DIMENSION(2) ::  remain_dims                     !< 
+    INTEGER(iwp) ::  ngp_yz_int   !< number of ghost points in yz-plane 
+    INTEGER(iwp) ::  type_xz_int  !< derived MPI datatype for 3-D integer ghost-point exchange - north / south
+    INTEGER(iwp) ::  type_yz_int  !< derived MPI datatype for 3-D integer ghost-point exchange - left / right
+
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ngp_xz      !< number of ghost points in xz-plane on different multigrid level
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  ngp_yz      !< number of ghost points in yz-plane on different multigrid level
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  type_x_int  !< derived MPI datatype for 2-D integer ghost-point exchange - north / south
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  type_xz     !< derived MPI datatype for 3-D integer ghost-point exchange - north / south
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  type_y_int  !< derived MPI datatype for 2-D integer ghost-point exchange - left / right
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE ::  type_yz     !< derived MPI datatype for 3-D integer ghost-point exchange - left / right 
+
+    LOGICAL ::  left_border_pe  = .FALSE.  !< = .TRUE. if PE is on left border of computational domain
+    LOGICAL ::  north_border_pe = .FALSE.  !< = .TRUE. if PE is on north border of computational domain
+    LOGICAL ::  reorder = .TRUE.           !< Siggi
+    LOGICAL ::  right_border_pe = .FALSE.  !< = .TRUE. if PE is on right border of computational domain
+    LOGICAL ::  south_border_pe = .FALSE.  !< = .TRUE. if PE is on south border of computational domain
+
+    LOGICAL, DIMENSION(2) ::  cyclic = (/ .TRUE. , .TRUE. /)  !< Siggi
+    LOGICAL, DIMENSION(2) ::  remain_dims                     !< Siggi
 #endif
 
@@ -1884,5 +1890,5 @@
     USE kinds
 
-    INTEGER(iwp), PARAMETER ::  crmax = 100  !< 
+    INTEGER(iwp), PARAMETER ::  crmax = 100  !< Siggi (entire module)
 
     CHARACTER (LEN=20), DIMENSION(20) ::  cross_ts_profiles = &  !< 
